%global use_qt5 1
%global use_qt6 1

%global appname QCoro

%global qt5_build_dir release-qt5
%global qt6_build_dir release-qt6

Name:           qcoro
Version:        0.7.0
Release:        %mkrel 1
Summary:        C++ Coroutines for Qt
Group:          Development/KDE and Qt
License:        MIT
URL:            https://github.com/danvratil/%{name}
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

%if 0%{?use_qt5}
BuildRequires:  cmake(Qt5Concurrent)
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5DBus)
BuildRequires:  cmake(Qt5Network)
BuildRequires:  cmake(Qt5Qml)
BuildRequires:  cmake(Qt5Quick)
BuildRequires:  cmake(Qt5Test)
BuildRequires:  cmake(Qt5WebSockets)
BuildRequires:  cmake(Qt5Widgets)
%endif

%if 0%{?use_qt6}
BuildRequires:  cmake(Qt6Concurrent)
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6DBus)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Qml)
BuildRequires:  cmake(Qt6Quick)
BuildRequires:  cmake(Qt6Test)
BuildRequires:  cmake(Qt6WebSockets)
BuildRequires:  cmake(Qt6Widgets)
%endif

BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  cmake
BuildRequires:  dbus-x11
BuildRequires:  ninja

%description
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%if 0%{?use_qt5}

%define qcoroqt5_major 0
%define libqcoro5core %mklibname qcoro5core %{qcoroqt5_major}

%package -n %{libqcoro5core}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt
Provides:       qcoro-qt5 = %{?epoch:%{epoch}:}%{version}-%{release}

Conflicts:      qcoro-qt5 < 0.6.0-2

%description -n %{libqcoro5core}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5dbus %mklibname qcoro5dbus %{qcoroqt5_major}

%package -n %{libqcoro5dbus}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt5 < 0.6.0-2

%description -n %{libqcoro5dbus}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5network %mklibname qcoro5network %{qcoroqt5_major}

%package -n %{libqcoro5network}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt5 < 0.6.0-2

%description -n %{libqcoro5network}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5qml %mklibname qcoro5qml %{qcoroqt5_major}

%package -n %{libqcoro5qml}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt

%description -n %{libqcoro5qml}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5quick %mklibname qcoro5quick %{qcoroqt5_major}

%package -n %{libqcoro5quick}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt

%description -n %{libqcoro5quick}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5websockets %mklibname qcoro5websockets %{qcoroqt5_major}

%package -n %{libqcoro5websockets}
Summary:        C++ Coroutines for Qt 5
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt5 < 0.6.0-2

%description -n %{libqcoro5websockets}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_devel %mklibname qcoro-qt5 -d

%package -n %{qcoroqt5_devel}
Summary:        Development files for %{appname} (Qt 5 version)
Group:          Development/KDE and Qt
Requires:       %{libqcoro5core} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro5dbus} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro5network} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro5qml} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro5quick} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro5websockets} = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:       %{name}-devel = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:       %{name}-qt5-devel = %{?epoch:%{epoch}:}%{version}-%{release}
Obsoletes:      qcoro-qt5-devel < 0.6.0-2

%description -n %{qcoroqt5_devel}
This package contains header files needed if you wish to build applications
based on %{appname} (Qt 5 version).
%endif

#--------------------------------------------------------------------

%if 0%{?use_qt6}

%define qcoroqt6_major 0
%define libqcoro6core %mklibname qcoro6core %{qcoroqt6_major}

%package -n %{libqcoro6core}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt
Provides:       qcoro-qt6 = %{?epoch:%{epoch}:}%{version}-%{release}

Conflicts:      qcoro-qt6 < 0.6.0-2

%description -n %{libqcoro6core}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_major 0
%define libqcoro6dbus %mklibname qcoro6dbus %{qcoroqt6_major}

%package -n %{libqcoro6dbus}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt6 < 0.6.0-2

%description -n %{libqcoro6dbus}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_major 0
%define libqcoro6network %mklibname qcoro6network %{qcoroqt6_major}

%package -n %{libqcoro6network}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt6 < 0.6.0-2

%description -n %{libqcoro6network}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_major 0
%define libqcoro6qml %mklibname qcoro6qml %{qcoroqt6_major}

%package -n %{libqcoro6qml}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt

%description -n %{libqcoro6qml}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_major 0
%define libqcoro6quick %mklibname qcoro6quick %{qcoroqt6_major}

%package -n %{libqcoro6quick}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt

%description -n %{libqcoro6quick}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_major 0
%define libqcoro6websockets %mklibname qcoro6websockets %{qcoroqt6_major}

%package -n %{libqcoro6websockets}
Summary:        C++ Coroutines for Qt 6
Group:          Development/KDE and Qt

Conflicts:      qcoro-qt6 < 0.6.0-2

%description -n %{libqcoro6websockets}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt6_devel %mklibname qcoro-qt6 -d

%package -n %{qcoroqt6_devel}
Summary:        Development files for %{appname} (Qt 6 version)
Group:          Development/KDE and Qt
Requires:       %{libqcoro6core} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro6dbus} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro6network} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro6qml} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro6quick} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{libqcoro6websockets} = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:       %{name}-qt6-devel = %{?epoch:%{epoch}:}%{version}-%{release}
Obsoletes:      qcoro-qt6-devel < 0.6.0-2

%description -n %{qcoroqt6_devel}
This package contains header files needed if you wish to build applications
based on %{appname} (Qt 6 version).
%endif

#--------------------------------------------------------------------

%prep
%autosetup -p1
sed -e '/-Werror/d' -i CMakeLists.txt

%build
%if 0%{?use_qt5}
mkdir %{qt5_build_dir} && pushd %{qt5_build_dir}
%cmake -G Ninja \
    -S'..' \
    -DCMAKE_BUILD_TYPE=Release \
    -DUSE_QT_VERSION:STRING=5 \
    -DBUILD_TESTING:BOOL=ON \
    -DQCORO_BUILD_EXAMPLES:BOOL=ON \
    -DQCORO_ENABLE_ASAN:BOOL=OFF \
    -DQCORO_WITH_QML:BOOL=ON \
    -DQCORO_WITH_QTDBUS:BOOL=ON \
    -DQCORO_WITH_QTNETWORK:BOOL=ON \
    -DQCORO_WITH_QTQUICK:BOOL=ON \
    -DQCORO_WITH_QTWEBSOCKETS:BOOL=ON
%cmake_build
popd
%endif

%if 0%{?use_qt6}
mkdir %{qt6_build_dir} && pushd %{qt6_build_dir}
%cmake -G Ninja \
    -S'..' \
    -DCMAKE_BUILD_TYPE=Release \
    -DUSE_QT_VERSION:STRING=6 \
    -DBUILD_TESTING:BOOL=ON \
    -DQCORO_BUILD_EXAMPLES:BOOL=ON \
    -DQCORO_ENABLE_ASAN:BOOL=OFF \
    -DQCORO_WITH_QML:BOOL=ON \
    -DQCORO_WITH_QTDBUS:BOOL=ON \
    -DQCORO_WITH_QTNETWORK:BOOL=ON \
    -DQCORO_WITH_QTQUICK:BOOL=ON \
    -DQCORO_WITH_QTWEBSOCKETS:BOOL=ON
%cmake_build
popd
%endif

%install
%if 0%{?use_qt5}
pushd %{qt5_build_dir}
%cmake_install
popd
%endif

%if 0%{?use_qt6}
pushd %{qt6_build_dir}
%cmake_install
popd
%endif

%check
%if 0%{?use_qt5}
pushd %{qt5_build_dir}
#%%ctest --timeout 3600 --exclude-regex 'qcoroimageprovider, qdbuspendingreply'
popd
%endif

%if 0%{?use_qt6}
pushd %{qt6_build_dir}
#%%ctest --timeout 3600 --exclude-regex 'qcoroimageprovider, qdbuspendingreply'
popd
%endif

%if 0%{?use_qt5}
%files -n %{libqcoro5core}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5Core.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Core.so.%{version}

%files -n %{libqcoro5dbus}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5DBus.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5DBus.so.%{version}

%files -n %{libqcoro5network}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5Network.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Network.so.%{version}

%files -n %{libqcoro5qml}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5Qml.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Qml.so.%{version}

%files -n %{libqcoro5quick}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5Quick.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Quick.so.%{version}

%files -n %{libqcoro5websockets}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro5WebSockets.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5WebSockets.so.%{version}

%files -n %{qcoroqt5_devel}
%{_includedir}/%{name}5/
%{_libdir}/cmake/%{appname}5*/
%{_libdir}/libQCoro5Core.so
%{_libdir}/libQCoro5DBus.so
%{_libdir}/libQCoro5Network.so
%{_libdir}/libQCoro5Qml.so
%{_libdir}/libQCoro5Quick.so
%{_libdir}/libQCoro5WebSockets.so
%{_libdir}/qt5/mkspecs/modules/qt_%{appname}*.pri
%endif

%if 0%{?use_qt6}
%files -n %{libqcoro6core}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6Core.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6Core.so.%{version}

%files -n %{libqcoro6dbus}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6DBus.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6DBus.so.%{version}

%files -n %{libqcoro6network}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6Network.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6Network.so.%{version}

%files -n %{libqcoro6qml}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6Qml.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6Qml.so.%{version}

%files -n %{libqcoro6quick}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6Quick.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6Quick.so.%{version}

%files -n %{libqcoro6websockets}
%doc README.md
%license LICENSES/*
%{_libdir}/libQCoro6WebSockets.so.%{qcoroqt6_major}
%{_libdir}/libQCoro6WebSockets.so.%{version}

%files -n %{qcoroqt6_devel}
%{_includedir}/%{name}6/
%{_libdir}/cmake/%{appname}6*/
%{_libdir}/libQCoro6Core.so
%{_libdir}/libQCoro6DBus.so
%{_libdir}/libQCoro6Network.so
%{_libdir}/libQCoro6Qml.so
%{_libdir}/libQCoro6Quick.so
%{_libdir}/libQCoro6WebSockets.so
%{_libdir}/qt6/mkspecs/modules/qt_%{appname}*.pri
%endif


%changelog
* Tue Dec 27 2022 daviddavid <daviddavid> 0.7.0-1.mga9
+ Revision: 1927197
- new version 0.7.0
- enable Qml and QtQuick support

* Tue Dec 27 2022 daviddavid <daviddavid> 0.6.0-2.mga9
+ Revision: 1927143
- libify pkgs

* Thu Aug 25 2022 papoteur <papoteur> 0.6.0-1.mga9
+ Revision: 1880354
- imported package qcoro


* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sat Jul 09 2022 Marc Deop <marcdeop@fedoraproject.org> - 0.6.0-1
- 0.6.0

* Sat May 07 2022 Vitaly Zaitsev <vitaly@easycoding.org> - 0.5.1-1
- Updated to version 0.5.1.

* Wed Mar 16 2022 Vitaly Zaitsev <vitaly@easycoding.org> - 0.4.0-4
- Enabled s390x build.

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Jan 09 2022 Vitaly Zaitsev <vitaly@easycoding.org> - 0.4.0-2
- Fixed summary in subpackages.

* Sun Jan 09 2022 Vitaly Zaitsev <vitaly@easycoding.org> - 0.4.0-1
- Updated to version 0.4.0.
- Separated Qt 5 and Qt 6 versions into a different subpackages.

* Mon Oct 25 2021 Vitaly Zaitsev <vitaly@easycoding.org> - 0.3.0-1
- Updated to version 0.3.0.

* Sat Oct 02 2021 Vitaly Zaitsev <vitaly@easycoding.org> - 0.2.0-1
- Initial SPEC release.
